/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-09-01 12:09
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MAXN = 100, INF = 1LL << 60;
string s, t;
ll N;

vector<vector<ll>> d;
bool floyd_warshall(int n){
  for(int k = 0; k < n; k++)
    for(int i = 0; i < n; i++)
      for(int j = 0; j < n; j++)
        if(d[i][k] != INF && d[k][j] != INF)
          d[i][j] =
            min(d[i][j], d[i][k] + d[k][j]);
  for(int i = 0; i < n; i++)
    if(d[i][i] < 0) return 1;
  return 0;
}


void solve(){
    // Code goes here ...
    cin >> s >> t;
    cin >> N;

    d.assign(MAXN, vector<ll>(MAXN, INF));
    R(i, MAXN) d[i][i] = 0;
    char a, b;
    ll cost;
    R(i, N){
        cin >> a >> b >> cost;
        assert(33 <= a and a <= 126);
        assert(33 <= b and b <= 126);
        ckmin(d[a - 33][b - 33], cost);
    }
    floyd_warshall(126 - 32);

    ll res = 0, tmp;
    R(i, ssize(s)){
        tmp = d[s[i] - 33][t[i] - 33];
        if(tmp == INF){
            res = -1;
            break;
        }
        res += tmp;
    }

    cout << res << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    solve();

    return 0;
}
        
